From e9f84beaddea856266ace2197929b866e3f38794 Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Wed, 6 May 2020 12:50:05 -0400
Subject: [PATCH 100/251] FIXME: make all svalue2 and region2 ptrs const,
 except in manager

---
 gcc/analyzer/checker-path.h         |   2 +-
 gcc/analyzer/constraint-manager2.cc |  53 +-
 gcc/analyzer/constraint-manager2.h  |  31 +-
 gcc/analyzer/diagnostic-manager.cc  |  14 +-
 gcc/analyzer/engine.cc              |  10 +-
 gcc/analyzer/program-state.cc       |  49 +-
 gcc/analyzer/program-state.h        |  26 +-
 gcc/analyzer/region-model2.cc       | 746 ++++++++++++++--------------
 gcc/analyzer/region-model2.h        | 392 ++++++++-------
 gcc/analyzer/store2.cc              |  48 +-
 gcc/analyzer/store2.h               |  38 +-
 11 files changed, 734 insertions(+), 675 deletions(-)

diff --git a/gcc/analyzer/checker-path.h b/gcc/analyzer/checker-path.h
index 8dcc5246dfa..72c8444c743 100644
--- a/gcc/analyzer/checker-path.h
+++ b/gcc/analyzer/checker-path.h
@@ -209,7 +209,7 @@ public:
     return m_dst_state.m_region_model->get_lvalue (expr, ctxt);
   }
 
-  region2* get_lvalue2 (tree expr, region_model2_context *ctxt) const
+  const region2* get_lvalue2 (tree expr, region_model2_context *ctxt) const
   {
     gcc_assert (m_dst_state.m_region_model2);
     return m_dst_state.m_region_model2->get_lvalue (expr, ctxt);
diff --git a/gcc/analyzer/constraint-manager2.cc b/gcc/analyzer/constraint-manager2.cc
index 87c7fe92593..03fe15ba286 100644
--- a/gcc/analyzer/constraint-manager2.cc
+++ b/gcc/analyzer/constraint-manager2.cc
@@ -179,7 +179,7 @@ equiv_class2::equiv_class2 (const equiv_class2 &other)
   m_vars (other.m_vars.length ())
 {
   int i;
-  svalue2 *sval;
+  const svalue2 *sval;
   FOR_EACH_VEC_ELT (other.m_vars, i, sval)
     m_vars.quick_push (sval);
 }
@@ -192,7 +192,7 @@ equiv_class2::print (pretty_printer *pp) const
 {
   pp_character (pp, '{');
   int i;
-  svalue2 *sval;
+  const svalue2 *sval;
   FOR_EACH_VEC_ELT (m_vars, i, sval)
     {
       if (i > 0)
@@ -215,7 +215,7 @@ equiv_class2::hash () const
 {
   inchash::hash hstate;
   int i;
-  svalue2 *sval;
+  const svalue2 *sval;
 
   inchash::add_expr (m_constant, hstate);
   // TODO:
@@ -240,7 +240,7 @@ equiv_class2::operator== (const equiv_class2 &other)
     return false;
 
   int i;
-  svalue2 *sval;
+  const svalue2 *sval;
   FOR_EACH_VEC_ELT (m_vars, i, sval)
     if (sval != other.m_vars[i])
       return false;
@@ -252,7 +252,7 @@ equiv_class2::operator== (const equiv_class2 &other)
 /* Add SID to this equiv_class2, using CM to check if it's a constant.  */
 
 void
-equiv_class2::add (svalue2 *sval)
+equiv_class2::add (const svalue2 *sval)
 {
   gcc_assert (sval);
   if (tree cst = sval->maybe_get_constant ())
@@ -271,13 +271,13 @@ equiv_class2::add (svalue2 *sval)
    a possible leak).  */
 
 bool
-equiv_class2::del (svalue2 *sval)
+equiv_class2::del (const svalue2 *sval)
 {
   gcc_assert (sval);
   gcc_assert (sval != m_cst_sval);
 
   int i;
-  svalue2 *iv;
+  const svalue2 *iv;
   FOR_EACH_VEC_ELT (m_vars, i, iv)
     {
       if (iv == sval)
@@ -296,7 +296,7 @@ equiv_class2::del (svalue2 *sval)
 /* Get a representative member of this class, for handling cases
    where the IDs can change mid-traversal.  */
 
-svalue2 *
+const svalue2 *
 equiv_class2::get_representative () const
 {
   if (m_cst_sval)
@@ -638,9 +638,9 @@ debug (const constraint_manager2 &cm)
    Return false if the constraint contradicts existing knowledge.  */
 
 bool
-constraint_manager2::add_constraint (svalue2 * lhs,
+constraint_manager2::add_constraint (const svalue2 *lhs,
 				     enum tree_code op,
-				     svalue2 * rhs)
+				     const svalue2 *rhs)
 {
   equiv_class2_id lhs_ec_id = get_or_add_equiv_class2 (lhs);
   equiv_class2_id rhs_ec_id = get_or_add_equiv_class2 (rhs);
@@ -680,7 +680,7 @@ constraint_manager2::add_constraint (equiv_class2_id lhs_ec_id,
 	const equiv_class2 &rhs_ec_obj = rhs_ec_id.get_obj (*this);
 
 	int i;
-	svalue2 *sval;
+	const svalue2 *sval;
 	FOR_EACH_VEC_ELT (rhs_ec_obj.m_vars, i, sval)
 	  lhs_ec_obj.add (sval);
 
@@ -761,8 +761,8 @@ constraint_manager2::add_constraint_internal (equiv_class2_id lhs_id,
       /* The following can potentially add EQ_EXPR facts, which could lead
 	 to ECs being merged, which would change the meaning of the EC IDs.
 	 Hence we need to do this via representatives.  */
-      svalue2 * lhs = lhs_id.get_obj (*this).get_representative ();
-      svalue2 * rhs = rhs_id.get_obj (*this).get_representative ();
+      const svalue2 *lhs = lhs_id.get_obj (*this).get_representative ();
+      const svalue2 *rhs = rhs_id.get_obj (*this).get_representative ();
 
       /* We have LHS </<= RHS */
 
@@ -835,7 +835,7 @@ constraint_manager2::add_constraint_internal (equiv_class2_id lhs_id,
 		      tree constant;
 		      if (r.constrained_to_single_element (&constant))
 			{
-			  svalue2 * cst_sval
+			  const svalue2 *cst_sval
 			    = m_mgr->get_or_create_constant_svalue2 (constant);
 			  add_constraint
 			    (rhs_id, EQ_EXPR,
@@ -868,7 +868,7 @@ constraint_manager2::add_constraint_internal (equiv_class2_id lhs_id,
 		      tree constant;
 		      if (r.constrained_to_single_element (&constant))
 			{
-			  svalue2 * cst_sval
+			  const svalue2 *cst_sval
 			    = m_mgr->get_or_create_constant_svalue2 (constant);
 			  add_constraint
 			    (lhs_id, EQ_EXPR,
@@ -892,7 +892,7 @@ constraint_manager2::add_constraint_internal (equiv_class2_id lhs_id,
    if found, write the id to *OUT and return true, otherwise return false.  */
 
 bool
-constraint_manager2::get_equiv_class2_by_svalue2 (svalue2 *sval,
+constraint_manager2::get_equiv_class2_by_svalue2 (const svalue2 *sval,
 						  equiv_class2_id *out) const
 {
   /* TODO: should we have a map, rather than these searches?  */
@@ -901,7 +901,7 @@ constraint_manager2::get_equiv_class2_by_svalue2 (svalue2 *sval,
   FOR_EACH_VEC_ELT (m_equiv_class2es, i, ec)
     {
       int j;
-      svalue2 *iv;
+      const svalue2 *iv;
       FOR_EACH_VEC_ELT (ec->m_vars, j, iv)
 	if (iv == sval)
 	  {
@@ -916,7 +916,7 @@ constraint_manager2::get_equiv_class2_by_svalue2 (svalue2 *sval,
    return the ID of the class.  */
 
 equiv_class2_id
-constraint_manager2::get_or_add_equiv_class2 (svalue2 *sval)
+constraint_manager2::get_or_add_equiv_class2 (const svalue2 *sval)
 {
   equiv_class2_id result (-1);
 
@@ -1057,9 +1057,9 @@ constraint_manager2::eval_condition (equiv_class2_id lhs_ec,
    LHS and RHS if they aren't already in equiv_class2es.  */
 
 tristate
-constraint_manager2::eval_condition (svalue2 *lhs,
+constraint_manager2::eval_condition (const svalue2 *lhs,
 				     enum tree_code op,
-				     svalue2 *rhs)
+				     const svalue2 *rhs)
 {
   return eval_condition (get_or_add_equiv_class2 (lhs),
 			 op,
@@ -1081,7 +1081,7 @@ constraint_manager2::purge (const purge_criteria2 &p, purge_stats2 *stats)
       equiv_class2 *ec = m_equiv_class2es[ec_idx];
 
       int i;
-      svalue2 *pv;
+      const svalue2 *pv;
       bool delete_ec = false;
       FOR_EACH_VEC_ELT (ec->m_vars, i, pv)
 	{
@@ -1319,7 +1319,7 @@ public:
   : m_cm_b (cm_b), m_out (out)
   {}
 
-  void on_fact (svalue2 *lhs, enum tree_code code, svalue2 *rhs)
+  void on_fact (const svalue2 *lhs, enum tree_code code, const svalue2 *rhs)
     FINAL OVERRIDE
   {
     if (m_cm_b->eval_condition (lhs, code, rhs).is_true ())
@@ -1401,10 +1401,11 @@ clean_merger_input (const constraint_manager2 &cm_in,
 	  cleaned_ec.m_cst_sval = out->get_sval_for_constant (cst);
 	}
       unsigned var_idx;
-      svalue2 **var_in_sval;
+      const svalue2 **var_in_sval;
       FOR_EACH_VEC_ELT (ec->m_vars, var_idx, var_in_sval)
 	{
-	  svalue2 *var_m_sval = map_sval_to_m.get_dst_for_src (*var_in_sval);
+	  const svalue2 *var_m_sval
+	    = map_sval_to_m.get_dst_for_src (*var_in_sval);
 	  if (!var_m_sval.null_p ())
 	    cleaned_ec.m_vars.safe_push (var_m_sval);
 	}
@@ -1449,7 +1450,7 @@ constraint_manager2::for_each_fact (fact2_visitor *visitor) const
       if (ec->m_cst_sval)
 	{
 	  unsigned i;
-	  svalue2 *sval;
+	  const svalue2 *sval;
 	  FOR_EACH_VEC_ELT (ec->m_vars, i, sval)
 	    visitor->on_fact (ec->m_cst_sval, EQ_EXPR, sval);
 	}
@@ -1501,7 +1502,7 @@ constraint_manager2::validate () const
       gcc_assert (ec);
 
       int j;
-      svalue2 *sval;
+      const svalue2 *sval;
       FOR_EACH_VEC_ELT (ec->m_vars, j, sval)
 	gcc_assert (sval);
       if (ec->m_constant)
diff --git a/gcc/analyzer/constraint-manager2.h b/gcc/analyzer/constraint-manager2.h
index 0b849e1876c..dc83d7c90e1 100644
--- a/gcc/analyzer/constraint-manager2.h
+++ b/gcc/analyzer/constraint-manager2.h
@@ -31,7 +31,7 @@ class purge_criteria2
 {
 public:
   virtual ~purge_criteria2 () {}
-  virtual bool should_purge_p (svalue2 *sval) const = 0;
+  virtual bool should_purge_p (const svalue2 *sval) const = 0;
 };
 
 /* An equivalence class within a constraint manager: a set of
@@ -47,12 +47,12 @@ public:
   hashval_t hash () const;
   bool operator== (const equiv_class2 &other);
 
-  void add (svalue2 *sval);
-  bool del (svalue2 *sval);
+  void add (const svalue2 *sval);
+  bool del (const svalue2 *sval);
 
   tree get_any_constant () const { return m_constant; }
 
-  svalue2 *get_representative () const;
+  const svalue2 *get_representative () const;
 
   void canonicalize ();
 
@@ -62,10 +62,10 @@ public:
      different zeroes, for different types); these are just for the last
      constant added.  */
   tree m_constant;
-  svalue2 *m_cst_sval;
+  const svalue2 *m_cst_sval;
 
   // TODO: should this be a set rather than a vec?
-  auto_vec<svalue2 *> m_vars;
+  auto_vec<const svalue2 *> m_vars;
 };
 
 /* The various kinds of constraint.  */
@@ -150,7 +150,9 @@ class fact2_visitor
 {
  public:
   virtual ~fact2_visitor () {}
-  virtual void on_fact (svalue2 *lhs, enum tree_code, svalue2 *rhs) = 0;
+  virtual void on_fact (const svalue2 *lhs,
+			enum tree_code,
+			const svalue2 *rhs) = 0;
 };
 
 /* A collection of equivalence classes and constraints on them.
@@ -192,26 +194,29 @@ public:
     return *m_equiv_class2es[idx];
   }
 
-  equiv_class2 &get_equiv_class2 (svalue2 *sval)
+  equiv_class2 &get_equiv_class2 (const svalue2 *sval)
   {
     equiv_class2_id ec_id = get_or_add_equiv_class2 (sval);
     return ec_id.get_obj (*this);
   }
 
-  bool add_constraint (svalue2 *lhs, enum tree_code op, svalue2 *rhs);
+  bool add_constraint (const svalue2 *lhs,
+		       enum tree_code op,
+		       const svalue2 *rhs);
 
   bool add_constraint (equiv_class2_id lhs_ec_id,
 		       enum tree_code op,
 		       equiv_class2_id rhs_ec_id);
 
-  bool get_equiv_class2_by_svalue2 (svalue2 *sval, equiv_class2_id *out) const;
-  equiv_class2_id get_or_add_equiv_class2 (svalue2 *sval);
+  bool get_equiv_class2_by_svalue2 (const svalue2 *sval,
+				    equiv_class2_id *out) const;
+  equiv_class2_id get_or_add_equiv_class2 (const svalue2 *sval);
   tristate eval_condition (equiv_class2_id lhs,
 			   enum tree_code op,
 			   equiv_class2_id rhs);
-  tristate eval_condition (svalue2 *lhs,
+  tristate eval_condition (const svalue2 *lhs,
 			   enum tree_code op,
-			   svalue2 *rhs);
+			   const svalue2 *rhs);
 
   void purge (const purge_criteria2 &p, purge_stats2 *stats);
 
diff --git a/gcc/analyzer/diagnostic-manager.cc b/gcc/analyzer/diagnostic-manager.cc
index 054baa42f44..be39037e01f 100644
--- a/gcc/analyzer/diagnostic-manager.cc
+++ b/gcc/analyzer/diagnostic-manager.cc
@@ -856,7 +856,7 @@ public:
 			state_machine::state_t src_sm_val,
 			state_machine::state_t dst_sm_val,
 			tree dst_rep,
-			svalue2 *dst_origin_sval) FINAL OVERRIDE
+			const svalue2 *dst_origin_sval) FINAL OVERRIDE
   {
     const exploded_node *src_node = m_eedge.m_src;
     const program_point &src_point = src_node->get_point ();
@@ -951,13 +951,13 @@ for_each_state_change2 (const program_state &src_state,
 #if 1
 	  // FIXME: we can compare them now
 	  // FIXME: do we want to sort them first, then emit events?
-	  svalue2 *sval = (*iter).first;
+	  const svalue2 *sval = (*iter).first;
 	  tree dst_rep = dst_state.get_representative_tree2 (sval);
 	  state_machine::state_t dst_sm_val = (*iter).second.m_state;
 	  state_machine::state_t src_sm_val = src_smap.get_state (sval);
 	  if (dst_sm_val != src_sm_val)
 	    {
-	      svalue2 *origin_sval = (*iter).second.m_origin;
+	      const svalue2 *origin_sval = (*iter).second.m_origin;
 	      if (visitor->on_state_change (sm, src_sm_val, dst_sm_val,
 					    dst_rep, origin_sval))
 		return true;
@@ -980,14 +980,14 @@ for_each_state_change2 (const program_state &src_state,
 		  >= src_state.m_region_model->get_stack_depth ())
 		continue;
 	      tentative_region_model_context ctxt;
-	      svalue2 *src_sval
+	      const svalue2 *src_sval
 		= src_state.m_region_model2->get_rvalue (*dst_pv, &ctxt);
 	      if (src_val == NULL || ctxt.had_errors_p ())
 		continue;
 	      state_machine::state_t src_sm_val = src_smap.get_state (src_sval);
 	      if (dst_sm_val != src_sm_val)
 		{
-		  svalue2 *dst_origin_sval = (*iter).second.m_origin;
+		  const svalue2 *dst_origin_sval = (*iter).second.m_origin;
 		  if (visitor->on_state_change (sm, src_sm_val, dst_sm_val,
 						dst_rep, dst_origin_sval))
 		    return true;
@@ -1406,9 +1406,9 @@ diagnostic_manager::prune_for_sm_diagnostic (checker_path *path,
 		   bulletproofing against cases where they can't have lvalues by
 		   using tentative_region_model_context.  */
 		tentative_region_model2_context ctxt;
-		region2 *state_var_reg
+		const region2 *state_var_reg
 		  = state_change->get_lvalue2 (state_change->m_var, &ctxt);
-		region2 *var_reg = state_change->get_lvalue2 (var, &ctxt);
+		const region2 *var_reg = state_change->get_lvalue2 (var, &ctxt);
 		ctxt_had_errors = ctxt.had_errors_p ();
 		same_region = (state_var_reg == var_reg && !ctxt.had_errors_p ());
 	      }
diff --git a/gcc/analyzer/engine.cc b/gcc/analyzer/engine.cc
index abd4b8eb105..c3af9e1059c 100644
--- a/gcc/analyzer/engine.cc
+++ b/gcc/analyzer/engine.cc
@@ -477,15 +477,15 @@ public:
     impl_region_model2_context old_ctxt
       (m_eg, m_enode_for_diag, NULL, NULL/*m_enode->get_state ()*/,
        m_change, stmt);
-    svalue2 *var_old_sval
+    const svalue2 *var_old_sval
       = m_old_state->m_region_model2->get_rvalue (var, &old_ctxt);
 
     impl_region_model2_context new_ctxt (m_eg, m_enode_for_diag,
 					 m_old_state, m_new_state,
 					 m_change, NULL);
-    svalue2 *var_new_sval
+    const svalue2 *var_new_sval
       = m_new_state->m_region_model2->get_rvalue (var, &new_ctxt);
-    svalue2 *origin_new_sval
+    const svalue2 *origin_new_sval
       = m_new_state->m_region_model2->get_rvalue (origin, &new_ctxt);
 
     state_machine::state_t current = m_old_smap->get_state (var_old_sval);
@@ -518,7 +518,7 @@ public:
     state_machine::state_t current;
     if (var)
       {
-	svalue2 *var_old_sval
+	const svalue2 *var_old_sval
 	  = m_old_state->m_region_model2->get_rvalue (var, &old_ctxt);
 	current = m_old_smap->get_state (var_old_sval);
       }
@@ -555,7 +555,7 @@ public:
     return expr;
 #else
     gcc_assert (m_new_state);
-    svalue2 *sval = m_new_state->m_region_model2->get_rvalue (expr, NULL);
+    const svalue2 *sval = m_new_state->m_region_model2->get_rvalue (expr, NULL);
     /* Find trees for all regions storing the value.  */
     auto_vec<path_var> pvs;
     m_new_state->m_region_model2->get_path_vars_for_svalue (sval, &pvs);
diff --git a/gcc/analyzer/program-state.cc b/gcc/analyzer/program-state.cc
index e14811367a2..7a28b2cc0b8 100644
--- a/gcc/analyzer/program-state.cc
+++ b/gcc/analyzer/program-state.cc
@@ -631,7 +631,7 @@ sm_state_map2::print (const state_machine &sm, const region_model2 *model,
       if (!first)
 	pp_string (pp, ", ");
       first = false;
-      svalue2 *sval = (*iter).first;
+      const svalue2 *sval = (*iter).first;
       sval->dump_to_pp (pp, false);
 
       entry_t e = (*iter).second;
@@ -727,7 +727,7 @@ sm_state_map2::operator== (const sm_state_map2 &other) const
        iter != m_map.end ();
        ++iter)
     {
-      svalue2 *sval = (*iter).first;
+      const svalue2 *sval = (*iter).first;
       entry_t e = (*iter).second;
       entry_t *other_slot = const_cast <map_t &> (other.m_map).get (sval);
       if (other_slot == NULL)
@@ -745,7 +745,7 @@ sm_state_map2::operator== (const sm_state_map2 &other) const
    States default to the start state.  */
 
 state_machine::state_t
-sm_state_map2::get_state (svalue2 *sval) const
+sm_state_map2::get_state (const svalue2 *sval) const
 {
   gcc_assert (sval);
 
@@ -758,8 +758,8 @@ sm_state_map2::get_state (svalue2 *sval) const
 
 /* Get the "origin" svalue2 for any state of SVAL.  */
 
-svalue2 *
-sm_state_map2::get_origin (svalue2 *sval) const
+const svalue2 *
+sm_state_map2::get_origin (const svalue2 *sval) const
 {
   gcc_assert (sval);
 
@@ -776,9 +776,9 @@ sm_state_map2::get_origin (svalue2 *sval) const
 
 void
 sm_state_map2::set_state (region_model2 *model,
-			  svalue2 *sval,
+			  const svalue2 *sval,
 			  state_machine::state_t state,
-			  svalue2 *origin)
+			  const svalue2 *origin)
 {
   if (model == NULL)
     return;
@@ -810,10 +810,10 @@ sm_state_map2::set_state (region_model2 *model,
 bool
 sm_state_map2::set_state (const equiv_class2 &ec,
 			  state_machine::state_t state,
-			  svalue2 *origin)
+			  const svalue2 *origin)
 {
   int i;
-  svalue2 *sval;
+  const svalue2 *sval;
   bool any_changed = false;
   FOR_EACH_VEC_ELT (ec.m_vars, i, sval)
     any_changed |= impl_set_state (sval, state, origin);
@@ -824,8 +824,9 @@ sm_state_map2::set_state (const equiv_class2 &ec,
    Return true if the state changed.  */
 
 bool
-sm_state_map2::impl_set_state (svalue2 *sval, state_machine::state_t state,
-			       svalue2 *origin)
+sm_state_map2::impl_set_state (const svalue2 *sval,
+			       state_machine::state_t state,
+			       const svalue2 *origin)
 {
   if (get_state (sval) == state)
     return false;
@@ -998,7 +999,7 @@ sm_state_map2::on_cast (svalue_id src_sid,
 /* Purge state from SID (in response to a call to an unknown function).  */
 
 void
-sm_state_map2::on_unknown_change (svalue2 *sval)
+sm_state_map2::on_unknown_change (const svalue2 *sval)
 {
   impl_set_state (sval, (state_machine::state_t)0, NULL);
 }
@@ -1742,7 +1743,7 @@ program_state::get_representative_tree (svalue_id sid) const
 /* FIXME.  */
 
 tree
-program_state::get_representative_tree2 (svalue2 *sval) const
+program_state::get_representative_tree2 (const svalue2 *sval) const
 {
   gcc_assert (m_region_model2);
   return m_region_model2->get_representative_tree (sval);
@@ -2390,9 +2391,9 @@ test_sm_state_map2 ()
   {
     region_model2_manager mgr;
     region_model2 model (&mgr);
-    svalue2 *x_sval = model.get_rvalue (x, NULL);
-    svalue2 *y_sval = model.get_rvalue (y, NULL);
-    svalue2 *z_sval = model.get_rvalue (z, NULL);
+    const svalue2 *x_sval = model.get_rvalue (x, NULL);
+    const svalue2 *y_sval = model.get_rvalue (y, NULL);
+    const svalue2 *z_sval = model.get_rvalue (z, NULL);
 
     sm_state_map2 map;
     ASSERT_TRUE (map.is_empty_p ());
@@ -2416,9 +2417,9 @@ test_sm_state_map2 ()
   {
     region_model2_manager mgr;
     region_model2 model (&mgr);
-    svalue2 *x_sval = model.get_rvalue (x, NULL);
-    svalue2 *y_sval = model.get_rvalue (y, NULL);
-    svalue2 *z_sval = model.get_rvalue (z, NULL);
+    const svalue2 *x_sval = model.get_rvalue (x, NULL);
+    const svalue2 *y_sval = model.get_rvalue (y, NULL);
+    const svalue2 *z_sval = model.get_rvalue (z, NULL);
 
     sm_state_map2 map;
     ASSERT_TRUE (map.is_empty_p ());
@@ -2440,8 +2441,8 @@ test_sm_state_map2 ()
   {
     region_model2_manager mgr;
     region_model2 model (&mgr);
-    svalue2 *y_sval = model.get_rvalue (y, NULL);
-    svalue2 *z_sval = model.get_rvalue (z, NULL);
+    const svalue2 *y_sval = model.get_rvalue (y, NULL);
+    const svalue2 *z_sval = model.get_rvalue (z, NULL);
 
     sm_state_map2 map0;
     sm_state_map2 map1;
@@ -2471,9 +2472,9 @@ test_sm_state_map2 ()
 
     region_model2_manager mgr;
     region_model2 model (&mgr);
-    svalue2 *x_sval = model.get_rvalue (x, NULL);
-    svalue2 *y_sval = model.get_rvalue (y, NULL);
-    svalue2 *z_sval = model.get_rvalue (z, NULL);
+    const svalue2 *x_sval = model.get_rvalue (x, NULL);
+    const svalue2 *y_sval = model.get_rvalue (y, NULL);
+    const svalue2 *z_sval = model.get_rvalue (z, NULL);
 
     map1.impl_set_state (x_sval, 2, NULL);
     map1.impl_set_state (y_sval, 3, NULL);
diff --git a/gcc/analyzer/program-state.h b/gcc/analyzer/program-state.h
index b2fcfcaee70..513f470f585 100644
--- a/gcc/analyzer/program-state.h
+++ b/gcc/analyzer/program-state.h
@@ -239,7 +239,7 @@ public:
     }
 
     entry_t (state_machine::state_t state,
-	     svalue2 *origin)
+	     const svalue2 *origin)
     : m_state (state), m_origin (origin)
     {}
 
@@ -254,9 +254,9 @@ public:
     }
 
     state_machine::state_t m_state;
-    svalue2 *m_origin;
+    const svalue2 *m_origin;
   };
-  typedef hash_map <svalue2 *, entry_t> map_t;
+  typedef hash_map <const svalue2 *, entry_t> map_t;
   typedef map_t::iterator iterator_t;
 
   sm_state_map2 ();
@@ -277,19 +277,19 @@ public:
     return !(*this == other);
   }
 
-  state_machine::state_t get_state (svalue2 *sval) const;
-  svalue2 *get_origin (svalue2 *sval) const;
+  state_machine::state_t get_state (const svalue2 *sval) const;
+  const svalue2 *get_origin (const svalue2 *sval) const;
 
   void set_state (region_model2 *model,
-		  svalue2 *sval,
+		  const svalue2 *sval,
 		  state_machine::state_t state,
-		  svalue2 *origin);
+		  const svalue2 *origin);
   bool set_state (const equiv_class2 &ec,
 		  state_machine::state_t state,
-		  svalue2 *origin);
-  bool impl_set_state (svalue2 *sval,
+		  const svalue2 *origin);
+  bool impl_set_state (const svalue2 *sval,
 		       state_machine::state_t state,
-		       svalue2 *origin);
+		       const svalue2 *origin);
 
   void set_global_state (state_machine::state_t state);
   state_machine::state_t get_global_state () const;
@@ -313,7 +313,7 @@ public:
 		svalue_id dst_sid);
 #endif
 
-  void on_unknown_change (svalue2 *sval);
+  void on_unknown_change (const svalue2 *sval);
 
 #if 0
   void validate (const state_machine &sm, int num_svalues) const;
@@ -385,7 +385,7 @@ public:
   void remap_svalue_ids (const svalue_id_map &map);
 
   tree get_representative_tree (svalue_id sid) const;
-  tree get_representative_tree2 (svalue2 *sval) const;
+  tree get_representative_tree2 (const svalue2 *sval) const;
 
   bool can_purge_p (const extrinsic_state &ext_state,
 		    svalue_id sid)
@@ -464,7 +464,7 @@ public:
 				state_machine::state_t src_sm_val,
 				state_machine::state_t dst_sm_val,
 				tree dst_rep,
-				svalue2 *dst_origin_sval) = 0;
+				const svalue2 *dst_origin_sval) = 0;
 };
 
 extern bool for_each_state_change2 (const program_state &src_state,
